﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using XServer;

namespace XCircle
{
    public partial class Form1 : Form
    {
        XMapWSService svcMap = new XMapWSService();
         
        double n = Properties.Settings.Default.n;
        double x = Properties.Settings.Default.x;
        double y = Properties.Settings.Default.y;
        double r = Properties.Settings.Default.r;
        MapSection dummyMapSection = new MapSection()
        {
            center = new XServer.Point
            {
                point = new PlainPoint()
                {
                    x = Properties.Settings.Default.x,
                    y = Properties.Settings.Default.y
                }
            },
            scale = 1000
        };
        ImageInfo imageInfo;

                
                           

        public Form1()
        {
            InitializeComponent();
            imageInfo = new ImageInfo()
            {
                format = ImageFileFormat.PNG,
                height = pbxMap.Height,
                width = pbxMap.Width
            };
            Form1_Load(null, null);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            List<PlainPoint> lstPlainPoints = new List<PlainPoint>();
            double arg = Math.PI * 2.0 / n;
            for (int index = 0 ; index<n ; index++)
                lstPlainPoints.Add(new PlainPoint(){
                    x = x + r * Math.Cos(arg * index),
                    y = y + r * Math.Sin(arg*index)});



            LineString circleLineString = new LineString()
            {
                lineString = new PlainLineString()
                {
                    wrappedPoints = lstPlainPoints.ToArray()
                }
            };

            CustomLayer cl = new CustomLayer()
            {
                centerObjects = true,
                name = "circle",
                drawPriority = 100,
                visible = true,
                wrappedLines = new Lines[]{
                    new Lines(){
                        wrappedLines = new LineString[]{
                            circleLineString}}}
            };


            Map map = svcMap.renderMap(dummyMapSection, null, imageInfo, new Layer[] { cl }, true, null);
            pbxMap.Image = System.Drawing.Image.FromStream(new System.IO.MemoryStream(map.image.rawImage));
            pbxMap.Update();
            pbxMap.Show();

        }
    }
}
